!MNH_LIC Copyright 1994-2019 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
MODULE MODI_ICE4_TENDENCIES
INTERFACE
SUBROUTINE ICE4_TENDENCIES(KSIZE, KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, &
                          &KRR, ODSOFT, ODCOMPUTE, &
                          &OWARM, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, HSUBG_AUCV_RC, HSUBG_PR_PDF, &
                          &PEXN, PRHODREF, PLVFACT, PLSFACT, K1, K2, K3, &
                          &PPRES, PCF, PSIGMA_RC, &
                          &PCIT, &
                          &PT, PTHT, &
                          &PRVT, PRCT, PRRT, PRIT, PRST, PRGT, PRHT, PRRT3D, &
                          &PRVHENI_MR, PRRHONG_MR, PRIMLTC_MR, PRSRIMCG_MR, &
                          &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
                          &PRCAUTR, PRCACCR, PRREVAV, &
                          &PRCRIMSS, PRCRIMSG, PRSRIMCG, PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, PRCMLTSR, &
                          &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                          &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                          &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                          &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                          &PRCBERI, &
                          &PRS_TEND, PRG_TEND, PRH_TEND, &
                          &PA_TH, PA_RV, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, &
                          &PB_TH, PB_RV, PB_RC, PB_RR, PB_RI, PB_RS, PB_RG, PB_RH, &
                          &PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC, PRAINFR)
IMPLICIT NONE
INTEGER,                      INTENT(IN)    :: KSIZE, KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL
INTEGER,                      INTENT(IN)    :: KRR
LOGICAL,                      INTENT(IN)    :: ODSOFT
LOGICAL, DIMENSION(KSIZE),    INTENT(IN)    :: ODCOMPUTE
LOGICAL,                      INTENT(IN)    :: OWARM
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_RC_RR_ACCR
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_RR_EVAP
CHARACTER(len=4),             INTENT(IN)    :: HSUBG_AUCV_RC
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_PR_PDF ! pdf for subgrid precipitation
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PEXN
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRHODREF
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PLVFACT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PLSFACT
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K1
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K2
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K3
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PPRES
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PCF
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PSIGMA_RC
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PCIT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PTHT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRVT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRCT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRRT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRIT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRST
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRGT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRHT
REAL, DIMENSION(KIT,KJT,KKT), INTENT(IN)    :: PRRT3D
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRVHENI_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRHONG_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIMLTC_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSRIMCG_MR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCHONI
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRVDEPS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRIAGGS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRIAUTS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRVDEPG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCAUTR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCACCR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRREVAV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCRIMSS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCRIMSG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSRIMCG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRACCSS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRACCSG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSACCRG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRSMLTG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCMLTSR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRICFRRG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRRCFRIG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRICFRR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRWETGH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRWETGH_MR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRGMLTR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRGWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRGDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRDRYHG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRHMLTR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCBERI
REAL, DIMENSION(KSIZE, 6),    INTENT(INOUT) :: PRS_TEND
REAL, DIMENSION(KSIZE, 6),    INTENT(INOUT) :: PRG_TEND
REAL, DIMENSION(KSIZE, 8),    INTENT(INOUT) :: PRH_TEND
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_TH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RI
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_TH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RI
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_HCF
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_LCF
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_HRC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_LRC
REAL, DIMENSION(KIT,KJT,KKT), INTENT(OUT)   :: PRAINFR   ! Rain fraction
END SUBROUTINE ICE4_TENDENCIES
END INTERFACE
END MODULE MODI_ICE4_TENDENCIES
SUBROUTINE ICE4_TENDENCIES(KSIZE, KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, &
                          &KRR, ODSOFT, ODCOMPUTE, &
                          &OWARM, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, HSUBG_AUCV_RC, HSUBG_PR_PDF, &
                          &PEXN, PRHODREF, PLVFACT, PLSFACT, K1, K2, K3, &
                          &PPRES, PCF, PSIGMA_RC, &
                          &PCIT, &
                          &PT, PTHT, &
                          &PRVT, PRCT, PRRT, PRIT, PRST, PRGT, PRHT, PRRT3D, &
                          &PRVHENI_MR, PRRHONG_MR, PRIMLTC_MR, PRSRIMCG_MR, &
                          &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
                          &PRCAUTR, PRCACCR, PRREVAV, &
                          &PRCRIMSS, PRCRIMSG, PRSRIMCG, PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, PRCMLTSR, &
                          &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                          &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                          &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                          &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                          &PRCBERI, &
                          &PRS_TEND, PRG_TEND, PRH_TEND, &
                          &PA_TH, PA_RV, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, &
                          &PB_TH, PB_RV, PB_RC, PB_RR, PB_RI, PB_RS, PB_RG, PB_RH, &
                          &PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC, PRAINFR)
!!
!!**  PURPOSE
!!    -------
!!      Computes the tendencies
!!
!!    AUTHOR
!!    ------
!!      S. Riette from the splitting of rain_ice source code (nov. 2014)
!!
!!    MODIFICATIONS
!!    -------------
!
!  P. Wautelet 29/05/2019: remove PACK/UNPACK intrinsics (to get more performance and better OpenACC support)
!
!
!*      0. DECLARATIONS
!          ------------
!
USE MODD_CST,            ONLY: XALPI,XBETAI,XCI,XCPV,XGAMI,XLSTT,XMD,XMV,XP00,XRV,XTT
USE MODD_RAIN_ICE_DESCR, ONLY: XLBDAS_MAX,XLBEXG,XLBEXH,XLBEXR,XLBEXS,XLBG,XLBH,XLBR,XLBS,XRTMIN
USE MODD_RAIN_ICE_PARAM, ONLY: XSCFAC
!
USE MODI_ICE4_COMPUTE_PDF
USE MODI_ICE4_FAST_RG
USE MODI_ICE4_FAST_RH
USE MODI_ICE4_FAST_RI
USE MODI_ICE4_FAST_RS
USE MODI_ICE4_NUCLEATION
USE MODI_ICE4_RAINFR_VERT
USE MODI_ICE4_RIMLTC
USE MODI_ICE4_RRHONG
USE MODI_ICE4_RSRIMCG_OLD
USE MODI_ICE4_SLOW
USE MODI_ICE4_WARM
!
#ifdef MNH_BITREP
USE MODI_BITREP
#endif
!
USE MODE_MPPDB
!
IMPLICIT NONE
!
!*       0.1   Declarations of dummy arguments :
!
INTEGER,                      INTENT(IN)    :: KSIZE, KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL
INTEGER,                      INTENT(IN)    :: KRR
LOGICAL,                      INTENT(IN)    :: ODSOFT
LOGICAL, DIMENSION(KSIZE),    INTENT(IN)    :: ODCOMPUTE
LOGICAL,                      INTENT(IN)    :: OWARM
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_RC_RR_ACCR
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_RR_EVAP
CHARACTER(len=4),             INTENT(IN)    :: HSUBG_AUCV_RC
CHARACTER(len=80),            INTENT(IN)    :: HSUBG_PR_PDF ! pdf for subgrid precipitation
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PEXN
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRHODREF
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PLVFACT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PLSFACT
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K1
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K2
INTEGER, DIMENSION(KSIZE),    INTENT(IN)    :: K3
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PPRES
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PCF
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PCIT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PTHT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRVT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRCT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRRT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRIT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRST
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRGT
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PRHT
REAL, DIMENSION(KIT,KJT,KKT), INTENT(IN)    :: PRRT3D
REAL, DIMENSION(KSIZE),       INTENT(IN)    :: PSIGMA_RC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRVHENI_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRHONG_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIMLTC_MR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSRIMCG_MR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCHONI
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRVDEPS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRIAGGS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRIAUTS
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRVDEPG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCAUTR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCACCR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRREVAV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCRIMSS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCRIMSG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSRIMCG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRACCSS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRACCSG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSACCRG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRSMLTG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCMLTSR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRICFRRG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRRCFRIG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRICFRR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSWETG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSDRYG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRWETGH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRWETGH_MR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRGMLTR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRGWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRWETH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRCDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRIDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRSDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRRDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRGDRYH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PRDRYHG
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRHMLTR
REAL, DIMENSION(KSIZE),       INTENT(INOUT) :: PRCBERI
REAL, DIMENSION(KSIZE, 6),    INTENT(INOUT) :: PRS_TEND
REAL, DIMENSION(KSIZE, 6),    INTENT(INOUT) :: PRG_TEND
REAL, DIMENSION(KSIZE, 8),    INTENT(INOUT) :: PRH_TEND
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_TH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RI
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PA_RH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_TH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RV
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RR
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RI
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RS
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RG
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PB_RH
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_HCF
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_LCF
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_HRC
REAL, DIMENSION(KSIZE),       INTENT(OUT)   :: PHLC_LRC
REAL, DIMENSION(KIT,KJT,KKT), INTENT(OUT)   :: PRAINFR   ! Rain fraction
!
!$acc declare present(KSIZE,KIB,KIE,KIT,KJB,KJE,KJT,KKB,KKE,KKT,KKL,KRR,ODSOFT,                                        &
!$acc&                OWARM,HSUBG_RC_RR_ACCR,HSUBG_RR_EVAP,HSUBG_AUCV_RC,HSUBG_PR_PDF)
!$acc declare present(ODCOMPUTE,PEXN,PRHODREF,PLVFACT,PLSFACT,K1,K2,K3,PPRES,PCF,PCIT,PT,PTHT,                         &
!$acc&                PRVT,PRCT,PRRT,PRIT,PRST,PRGT,PRHT,PRRT3D,PSIGMA_RC,PRVHENI_MR,PRRHONG_MR,PRIMLTC_MR,            &
!$acc&                PRSRIMCG_MR,PRCHONI,PRVDEPS,PRIAGGS,PRIAUTS,PRVDEPG,PRCAUTR,PRCACCR,PRREVAV,                     &
!$acc&                PRCRIMSS,PRCRIMSG,PRSRIMCG,PRRACCSS,PRRACCSG,PRSACCRG,PRSMLTG,PRCMLTSR,PRICFRRG,PRRCFRIG,        &
!$acc&                PRICFRR,PRCWETG,PRIWETG,PRRWETG,PRSWETG,PRCDRYG,PRIDRYG,PRRDRYG,PRSDRYG,                         &
!$acc&                PRWETGH,PRWETGH_MR,PRGMLTR,PRCWETH,PRIWETH,PRSWETH,PRGWETH,PRRWETH,                              &
!$acc&                PRCDRYH,PRIDRYH,PRSDRYH,PRRDRYH,PRGDRYH,PRDRYHG,PRHMLTR,PRCBERI,PRS_TEND,PRG_TEND,PRH_TEND,      &
!$acc&                PA_TH,PA_RV,PA_RC,PA_RR,PA_RI,PA_RS,PA_RG,PA_RH,PB_TH,PB_RV,PB_RC,PB_RR,PB_RI,PB_RS,PB_RG,PB_RH, &
!$acc&                PHLC_HCF,PHLC_LCF,PHLC_HRC,PHLC_LRC,PRAINFR)
!
!*       0.2  declaration of local variables
!
INTEGER                      :: IDX,JI,JJ,JK,JL
INTEGER                      :: IRR, ISIZE
LOGICAL                      :: GDSOFT, GWARM !Workaround of PGI bug with OpenACC (at least up to 18.10 version)
LOGICAL, DIMENSION(KSIZE)    :: LLWETG
REAL,    DIMENSION(KSIZE)    :: ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, &
                              & ZT, ZTHT, &
                              & ZZW, &
                              & ZSSI, ZKA, ZDV, ZAI, ZCJ, &
                              & ZRF, &
                              & ZLBDAR, ZLBDAS, ZLBDAG, ZLBDAH, ZLBDAR_RF, &
                              & ZRGSI, ZRGSI_MR
REAL, DIMENSION(KIT,KJT,KKT) :: ZRRT3D
!
!$acc declare create(ZRVT,ZRCT,ZRRT,ZRIT,ZRST,ZRGT,ZT,ZTHT,ZZW,ZSSI,ZKA,ZDV,ZAI,ZCJ,ZRF,               &
!$acc&               ZLBDAR,ZLBDAS,ZLBDAG,ZLBDAH,ZLBDAR_RF,ZRGSI,ZRGSI_MR,ZRRT3D,IDX,JI,JJ,JK,JL,LLWETG)
!
!$acc declare copyin(XALPI,XBETAI,XCI,XCPV,XGAMI,XLSTT,XMD,XMV,XP00,XRV,XTT,          &
!$acc&               XSCFAC,                                                          &
!$acc&               XLBDAS_MAX,XLBEXG,XLBEXH,XLBEXR,XLBEXS,XLBG,XLBH,XLBR,XLBS,XRTMIN)
!
IF (MPPDB_INITIALIZED) THEN
  !Check all IN arrays
  CALL MPPDB_CHECK(PEXN,"ICE4_TENDENCIES beg:PEXN")
  CALL MPPDB_CHECK(PRHODREF,"ICE4_TENDENCIES beg: PRHODREF:")
  CALL MPPDB_CHECK(PLVFACT,"ICE4_TENDENCIES beg:PLVFACT")
  CALL MPPDB_CHECK(PLSFACT,"ICE4_TENDENCIES beg:PLSFACT")
  CALL MPPDB_CHECK(K1,"ICE4_TENDENCIES beg:K1")
  CALL MPPDB_CHECK(K2,"ICE4_TENDENCIES beg:K2")
  CALL MPPDB_CHECK(K3,"ICE4_TENDENCIES beg:K3")
  CALL MPPDB_CHECK(PPRES,"ICE4_TENDENCIES beg:PPRES")
  CALL MPPDB_CHECK(PCF,"ICE4_TENDENCIES beg:PCF")
  CALL MPPDB_CHECK(PT,"ICE4_TENDENCIES beg:PT")
  CALL MPPDB_CHECK(PTHT,"ICE4_TENDENCIES beg:PTHT")
  CALL MPPDB_CHECK(PRVT,"ICE4_TENDENCIES beg:PRVT")
  CALL MPPDB_CHECK(PRCT,"ICE4_TENDENCIES beg:PRCT")
  CALL MPPDB_CHECK(PRRT,"ICE4_TENDENCIES beg:PRRT")
  CALL MPPDB_CHECK(PRIT,"ICE4_TENDENCIES beg:PRIT")
  CALL MPPDB_CHECK(PRST,"ICE4_TENDENCIES beg:PRST")
  CALL MPPDB_CHECK(PRGT,"ICE4_TENDENCIES beg:PRGT")
  CALL MPPDB_CHECK(PRHT,"ICE4_TENDENCIES beg:PRHT")
  CALL MPPDB_CHECK(PRRT3D,"ICE4_TENDENCIES beg:PRRT3D")
  CALL MPPDB_CHECK(PSIGMA_RC,"ICE4_TENDENCIES beg:PSIGMA_RC")
  !Check all INOUT arrays
  CALL MPPDB_CHECK(PCIT,"ICE4_TENDENCIES beg:PCIT")
  CALL MPPDB_CHECK(PRCHONI,"ICE4_TENDENCIES beg:PRCHONI")
  CALL MPPDB_CHECK(PRVDEPS,"ICE4_TENDENCIES beg:PRVDEPS")
  CALL MPPDB_CHECK(PRIAGGS,"ICE4_TENDENCIES beg:PRIAGGS")
  CALL MPPDB_CHECK(PRIAUTS,"ICE4_TENDENCIES beg:PRIAUTS")
  CALL MPPDB_CHECK(PRVDEPG,"ICE4_TENDENCIES beg:PRVDEPG")
  CALL MPPDB_CHECK(PRCAUTR,"ICE4_TENDENCIES beg:PRCAUTR")
  CALL MPPDB_CHECK(PRCACCR,"ICE4_TENDENCIES beg:PRCACCR")
  CALL MPPDB_CHECK(PRREVAV,"ICE4_TENDENCIES beg:PRREVAV")
  CALL MPPDB_CHECK(PRSMLTG,"ICE4_TENDENCIES beg:PRSMLTG")
  CALL MPPDB_CHECK(PRCMLTSR,"ICE4_TENDENCIES beg:PRCMLTSR")
  CALL MPPDB_CHECK(PRICFRRG,"ICE4_TENDENCIES beg:PRICFRRG")
  CALL MPPDB_CHECK(PRRCFRIG,"ICE4_TENDENCIES beg:PRRCFRIG")
  CALL MPPDB_CHECK(PRICFRR,"ICE4_TENDENCIES beg:PRICFRR")
  CALL MPPDB_CHECK(PRGMLTR,"ICE4_TENDENCIES beg:PRGMLTR")
  CALL MPPDB_CHECK(PRHMLTR,"ICE4_TENDENCIES beg:PRHMLTR")
  CALL MPPDB_CHECK(PRCBERI,"ICE4_TENDENCIES beg:PRCBERI")
  CALL MPPDB_CHECK(PRS_TEND,"ICE4_TENDENCIES beg:PRS_TEND")
  CALL MPPDB_CHECK(PRG_TEND,"ICE4_TENDENCIES beg:PRG_TEND")
  CALL MPPDB_CHECK(PRH_TEND,"ICE4_TENDENCIES beg:PRH_TEND")
END IF
!
!Workaround of PGI bug with OpenACC (at least up to 18.10 version)
!$acc kernels
GDSOFT = ODSOFT
GWARM  = OWARM
!$acc end kernels
!
!$acc data copyin(GDSOFT)
!
!$acc kernels
IRR = KRR
ISIZE = KSIZE
!$acc end kernels
#ifdef _OPENACC
!Check if KRR and KSIZE have the same value on host and device
IF (IRR/=KRR) THEN
  CALL PRINT_MSG(NVERB_FATAL,'GEN','ICE4_TENDENCIES','OpenACC: KRR different between host and device')
END IF
IF (ISIZE/=KSIZE) THEN
  CALL PRINT_MSG(NVERB_FATAL,'GEN','ICE4_TENDENCIES','OpenACC: KSIZE different between host and device')
END IF
#endif
!
!$acc kernels
PA_TH(:)=0.
PA_RV(:)=0.
PA_RC(:)=0.
PA_RR(:)=0.
PA_RI(:)=0.
PA_RS(:)=0.
PA_RG(:)=0.
PA_RH(:)=0.
PB_TH(:)=0.
PB_RV(:)=0.
PB_RC(:)=0.
PB_RR(:)=0.
PB_RI(:)=0.
PB_RS(:)=0.
PB_RG(:)=0.
PB_RH(:)=0.
!
ZRVT(:)=PRVT(:)
ZRCT(:)=PRCT(:)
ZRRT(:)=PRRT(:)
ZRIT(:)=PRIT(:)
ZRST(:)=PRST(:)
ZRGT(:)=PRGT(:)
ZTHT(:)=PTHT(:)
ZT(:)=PT(:)
!$acc end kernels
!
!*       2.     COMPUTES THE SLOW COLD PROCESS SOURCES
!               --------------------------------------
CALL ICE4_NUCLEATION(KSIZE, GDSOFT, ODCOMPUTE, &
                     ZTHT, PPRES, PRHODREF, PEXN, PLSFACT, ZT, &
                     ZRVT, &
                     PCIT, PRVHENI_MR, PB_TH, PB_RV, PB_RI)
!$acc kernels
ZRIT(:)=ZRIT(:) + PRVHENI_MR(:)
ZRVT(:)=ZRVT(:) - PRVHENI_MR(:)
ZTHT(:)=ZTHT(:) + PRVHENI_MR(:)*PLSFACT(:)
ZT(:) = ZTHT(:) * PEXN(:)
!$acc end kernels
!
!*       3.3     compute the spontaneous freezing source: RRHONG
!
CALL ICE4_RRHONG(KSIZE, GDSOFT, ODCOMPUTE, &
                &PEXN, PLVFACT, PLSFACT, &
                &ZT,   ZRRT, &
                &ZTHT, &
                &PRRHONG_MR, PB_TH, PB_RR, PB_RG)
!$acc kernels
ZRGT(:) = ZRGT(:) + PRRHONG_MR(:)
ZRRT(:) = ZRRT(:) - PRRHONG_MR(:)
ZTHT(:) = ZTHT(:) + PRRHONG_MR(:)*(PLSFACT(:)-PLVFACT(:)) ! f(L_f*(RRHONG))
ZT(:) = ZTHT(:) * PEXN(:)
!$acc end kernels
!
!*       7.1    cloud ice melting
!
CALL ICE4_RIMLTC(KSIZE, GDSOFT, ODCOMPUTE, &
                &PEXN, PLVFACT, PLSFACT, &
                &ZT, &
                &ZTHT, ZRIT, &
                &PRIMLTC_MR, PB_TH, PB_RC, PB_RI)
!$acc kernels
ZRCT(:) = ZRCT(:) + PRIMLTC_MR(:)
ZRIT(:) = ZRIT(:) - PRIMLTC_MR(:)
ZTHT(:) = ZTHT(:) - PRIMLTC_MR(:)*(PLSFACT(:)-PLVFACT(:)) ! f(L_f*(-RIMLTC))
ZT(:) = ZTHT(:) * PEXN(:)
!
!        5.1.6  riming-conversion of the large sized aggregates into graupel (old parametrisation)
!
ZLBDAS(:)=0.
WHERE(ZRST(:)>0.)
#ifndef MNH_BITREP
  ZLBDAS(:)  = MIN(XLBDAS_MAX, XLBS*(PRHODREF(:)*MAX(ZRST(:), XRTMIN(5)))**XLBEXS)
#else
  ZLBDAS(:)  = MIN(XLBDAS_MAX, XLBS*BR_POW(PRHODREF(:)*MAX(ZRST(:), XRTMIN(5)),XLBEXS))
#endif
END WHERE
!$acc end kernels
CALL ICE4_RSRIMCG_OLD(KSIZE, GDSOFT, ODCOMPUTE, &
                     &PRHODREF, &
                     &ZLBDAS, &
                     &ZT, ZRCT, ZRST, &
                     &PRSRIMCG_MR, PB_RS, PB_RG)
!$acc kernels
ZRST(:) = ZRST(:) - PRSRIMCG_MR(:)
ZRGT(:) = ZRGT(:) + PRSRIMCG_MR(:)
!$acc end kernels
!
!* Derived fields
!
IF(KSIZE>0) THEN
!$acc kernels
#ifndef MNH_BITREP
  ZZW(:) = EXP(XALPI-XBETAI/ZT(:)-XGAMI*ALOG(ZT(:)))
#else
  ZZW(:) = BR_EXP(XALPI-XBETAI/ZT(:)-XGAMI*BR_LOG(ZT(:)))
#endif
!$acc loop independent
  DO JL=1, KSIZE
    ZSSI(JL) = ZRVT(JL)*( PPRES(JL)-ZZW(JL) ) / ( (XMV/XMD) * ZZW(JL) ) - 1.0
                                                      ! Supersaturation over ice
    ZKA(JL) = 2.38E-2 + 0.0071E-2*(ZT(JL)-XTT) ! k_a
#ifndef MNH_BITREP
    ZDV(JL) = 0.211E-4*(ZT(JL)/XTT)**1.94 * (XP00/PPRES(JL)) ! D_v
    ZAI(JL) = (XLSTT+(XCPV-XCI)*(ZT(JL)-XTT))**2 / (ZKA(JL)*XRV*ZT(JL)**2) &
                                 + ( XRV*ZT(JL) ) / (ZDV(JL)*ZZW(JL))
    ZCJ(JL) = XSCFAC*PRHODREF(JL)**0.3 / SQRT(1.718E-5+0.0049E-5*(ZT(JL)-XTT))
#else
    ZDV(JL) = 0.211E-4*BR_POW(ZT(JL)/XTT,1.94) * (XP00/PPRES(JL)) ! D_v
    ZAI(JL) = BR_P2(XLSTT+(XCPV-XCI)*(ZT(JL)-XTT)) / (ZKA(JL)*XRV*BR_P2(ZT(JL))) &
                                 + ( XRV*ZT(JL) ) / (ZDV(JL)*ZZW(JL))
    ZCJ(JL) = XSCFAC*BR_POW(PRHODREF(JL),0.3) / SQRT(1.718E-5+0.0049E-5*(ZT(JL)-XTT))
#endif
  ENDDO
!$acc end kernels
  !
  !Cloud water split between high and low content part is done here
  CALL ICE4_COMPUTE_PDF(KSIZE, HSUBG_AUCV_RC, HSUBG_PR_PDF,&
                        PRHODREF, ZRCT, PCF, PSIGMA_RC,&
                        PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC, ZRF)
  !Diagnostic of precipitation fraction
!$acc kernels
  PRAINFR(:,:,:) = 0.
  ZRRT3D (:,:,:) = PRRT3D(:,:,:)
!$acc loop independent
  DO JL=1,KSIZE
    PRAINFR(K1(JL), K2(JL), K3(JL)) = ZRF(JL)
    ZRRT3D (K1(JL), K2(JL), K3(JL)) = ZRRT3D(K1(JL), K2(JL), K3(JL)) - PRRHONG_MR(JL)
  END DO
!$acc end kernels
  CALL ICE4_RAINFR_VERT(KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, PRAINFR(:,:,:), ZRRT3D(:,:,:))
!$acc kernels
!$acc loop independent
  DO JL=1,KSIZE
    ZRF(JL)=PRAINFR(K1(JL), K2(JL), K3(JL))
  END DO
  !
  !*  compute the slope parameters
  !
  ZLBDAS(:)=0.
  WHERE(ZRST(:)>0.)
#ifndef MNH_BITREP
    ZLBDAS(:)  = MIN(XLBDAS_MAX, XLBS*(PRHODREF(:)*MAX(ZRST(:), XRTMIN(5)))**XLBEXS)
#else
    ZLBDAS(:)  = MIN(XLBDAS_MAX, XLBS*BR_POW(PRHODREF(:)*MAX(ZRST(:), XRTMIN(5)),XLBEXS))
#endif
  END WHERE
  ZLBDAG(:)=0.
  WHERE(ZRGT(:)>0.)
#ifndef MNH_BITREP
    ZLBDAG(:)  = XLBG*(PRHODREF(:)*MAX(ZRGT(:), XRTMIN(6)))**XLBEXG
#else
    ZLBDAG(:)  = XLBG*BR_POW(PRHODREF(:)*MAX(ZRGT(:), XRTMIN(6)),XLBEXG)
#endif
  END WHERE
  !ZLBDAR will be used when we consider rain diluted over the grid box
  ZLBDAR(:)=0.
  WHERE(ZRRT(:)>0.)
#ifndef MNH_BITREP
    ZLBDAR(:)  = XLBR*( PRHODREF(:)*MAX( ZRRT(:), XRTMIN(3)))**XLBEXR
#else
    ZLBDAR(:)  = XLBR*BR_POW(PRHODREF(:)*MAX( ZRRT(:), XRTMIN(3)),XLBEXR)
#endif
  END WHERE
  !ZLBDAR_RF is used when we consider rain concentrated in its fraction
  ZLBDAR_RF(:)=0.
  WHERE(ZRRT(:)>0. .AND. ZRF(:)>0.)
#ifndef MNH_BITREP
    ZLBDAR_RF(:) = XLBR*( PRHODREF(:) *MAX( ZRRT(:)/ZRF(:) , XRTMIN(3)))**XLBEXR
#else
    ZLBDAR_RF(:) = XLBR*BR_POW(PRHODREF(:) *MAX( ZRRT(:)/ZRF(:) , XRTMIN(3)),XLBEXR)
#endif
  END WHERE
  IF(IRR==7) THEN
    ZLBDAH(:)=0.
    WHERE(PRHT(:)>0.)
#ifndef MNH_BITREP
      ZLBDAH(:) = XLBH*(PRHODREF(:)*MAX(PRHT(:), XRTMIN(7)))**XLBEXH
#else
      ZLBDAH(:) = XLBH*BR_POW(PRHODREF(:)*MAX(PRHT(:), XRTMIN(7)),XLBEXH)
#endif
    END WHERE
  ENDIF
!$acc end kernels
ENDIF
!
!
!PW:BUG: the following line is necessary for correct computation (at least for PGI 18.10)
if(irr==-1) print *,'PW: ICE4_TENDENCIES: GDSOFT (cpu)=',GDSOFT
CALL ICE4_SLOW(KSIZE, GDSOFT, ODCOMPUTE, PRHODREF, ZT, &
              &ZSSI, PLVFACT, PLSFACT, &
              &ZRVT, ZRCT, ZRIT, ZRST, ZRGT, &
              &ZLBDAS, ZLBDAG, &
              &ZAI, ZCJ, &
              &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
              &PA_TH, PA_RV, PA_RC, PA_RI, PA_RS, PA_RG)
!
!-------------------------------------------------------------------------------
!
!
!*       3.     COMPUTES THE SLOW WARM PROCESS SOURCES
!               --------------------------------------
!
!
IF(GWARM) THEN    !  Check if the formation of the raindrops by the slow
                  !  warm processes is allowed
  CALL ICE4_WARM(KSIZE, GDSOFT, ODCOMPUTE, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, &
                &PRHODREF, PLVFACT, ZT, PPRES, ZTHT,&
                &ZLBDAR, ZLBDAR_RF, ZKA, ZDV, ZCJ, &
                &PHLC_LCF, PHLC_HCF, PHLC_LRC, PHLC_HRC, &
                &PCF, ZRF, &
                &ZRVT, ZRCT, ZRRT, &
                &PRCAUTR, PRCACCR, PRREVAV, &
                &PA_TH, PA_RV, PA_RC, PA_RR)
ELSE
!$acc kernels
  PRCAUTR(:)=0.
  PRCACCR(:)=0.
  PRREVAV(:)=0.
!$acc end kernels
END IF
!
!-------------------------------------------------------------------------------
!
!
!*       4.     COMPUTES THE FAST COLD PROCESS SOURCES FOR r_s
!               ----------------------------------------------
!
CALL ICE4_FAST_RS(KSIZE, GDSOFT, ODCOMPUTE, &
                 &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                 &ZDV, ZKA, ZCJ, &
                 &ZLBDAR, ZLBDAS, &
                 &ZT, ZRVT, ZRCT, ZRRT, ZRST, &
                 &PRIAGGS, &
                 &PRCRIMSS, PRCRIMSG, PRSRIMCG, &
                 &PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, &
                 &PRCMLTSR, &
                 &PRS_TEND, &
                 &PA_TH, PA_RC, PA_RR, PA_RS, PA_RG)
!
!-------------------------------------------------------------------------------
!
!
!*       5.        COMPUTES THE FAST COLD PROCESS SOURCES FOR r_g
!                  ------------------------------------------------------
!
!$acc kernels
ZRGSI(:) = PRVDEPG(:) + PRSMLTG(:) + PRRACCSG(:) + PRSACCRG(:) + PRCRIMSG(:) + PRSRIMCG(:)
ZRGSI_MR(:) = PRRHONG_MR(:) + PRSRIMCG_MR(:)
!$acc end kernels
CALL ICE4_FAST_RG(KSIZE, GDSOFT, ODCOMPUTE, KRR, &
                 &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                 &ZDV, ZKA, ZCJ, PCIT, &
                 &ZLBDAR, ZLBDAS, ZLBDAG, &
                 &ZT, ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, &
                 &ZRGSI, ZRGSI_MR(:), &
                 &LLWETG, &
                 &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                 &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                 &PRG_TEND, &
                 &PA_TH, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, PB_RG, PB_RH)
!
!-------------------------------------------------------------------------------
!
!
!*       6.     COMPUTES THE FAST COLD PROCESS SOURCES FOR r_h
!               ----------------------------------------------
!
IF (KRR==7) THEN
  CALL ICE4_FAST_RH(KSIZE, GDSOFT, ODCOMPUTE, LLWETG, &
                   &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                   &ZDV, ZKA, ZCJ, &
                   &ZLBDAS, ZLBDAG, ZLBDAR, ZLBDAH, &
                   &ZT,  ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, PRHT, &
                   &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                   &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                   &PRH_TEND, &
                   &PA_TH, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH)
ELSE
!$acc kernels
  PRCWETH(:)=0.
  PRIWETH(:)=0.
  PRSWETH(:)=0.
  PRGWETH(:)=0.
  PRRWETH(:)=0.
  PRCDRYH(:)=0.
  PRIDRYH(:)=0.
  PRSDRYH(:)=0.
  PRRDRYH(:)=0.
  PRGDRYH(:)=0.
  PRDRYHG(:)=0.
  PRHMLTR(:)=0.
!$acc end kernels
END IF
!
!-------------------------------------------------------------------------------
!
!
!*       7.     COMPUTES SPECIFIC SOURCES OF THE WARM AND COLD CLOUDY SPECIES
!               -------------------------------------------------------------
!
CALL ICE4_FAST_RI(KSIZE, GDSOFT, ODCOMPUTE, &
                 &PRHODREF, PLVFACT, PLSFACT, &
                 &ZAI, ZCJ, PCIT, &
                 &ZSSI, &
                 &ZRCT, ZRIT, &
                 &PRCBERI, PA_TH, PA_RC, PA_RI)
!
!$acc end data
!
IF (MPPDB_INITIALIZED) THEN
  !Check all INOUT arrays
  CALL MPPDB_CHECK(PCIT,"ICE4_TENDENCIES end:PCIT")
  CALL MPPDB_CHECK(PRCHONI,"ICE4_TENDENCIES end:PRCHONI")
  CALL MPPDB_CHECK(PRVDEPS,"ICE4_TENDENCIES end:PRVDEPS")
  CALL MPPDB_CHECK(PRIAGGS,"ICE4_TENDENCIES end:PRIAGGS")
  CALL MPPDB_CHECK(PRIAUTS,"ICE4_TENDENCIES end:PRIAUTS")
  CALL MPPDB_CHECK(PRVDEPG,"ICE4_TENDENCIES end:PRVDEPG")
  CALL MPPDB_CHECK(PRCAUTR,"ICE4_TENDENCIES end:PRCAUTR")
  CALL MPPDB_CHECK(PRCACCR,"ICE4_TENDENCIES end:PRCACCR")
  CALL MPPDB_CHECK(PRREVAV,"ICE4_TENDENCIES end:PRREVAV")
  CALL MPPDB_CHECK(PRSMLTG,"ICE4_TENDENCIES end:PRSMLTG")
  CALL MPPDB_CHECK(PRCMLTSR,"ICE4_TENDENCIES end:PRCMLTSR")
  CALL MPPDB_CHECK(PRICFRRG,"ICE4_TENDENCIES end:PRICFRRG")
  CALL MPPDB_CHECK(PRRCFRIG,"ICE4_TENDENCIES end:PRRCFRIG")
  CALL MPPDB_CHECK(PRICFRR,"ICE4_TENDENCIES end:PRICFRR")
  CALL MPPDB_CHECK(PRGMLTR,"ICE4_TENDENCIES end:PRGMLTR")
  CALL MPPDB_CHECK(PRHMLTR,"ICE4_TENDENCIES end:PRHMLTR")
  CALL MPPDB_CHECK(PRCBERI,"ICE4_TENDENCIES end:PRCBERI")
  CALL MPPDB_CHECK(PRS_TEND,"ICE4_TENDENCIES end:PRS_TEND")
  CALL MPPDB_CHECK(PRG_TEND,"ICE4_TENDENCIES end:PRG_TEND")
  CALL MPPDB_CHECK(PRH_TEND,"ICE4_TENDENCIES end:PRH_TEND")
  !Check all OUT arrays
  CALL MPPDB_CHECK(PRCRIMSS,"ICE4_TENDENCIES end:PRCRIMSS")
  CALL MPPDB_CHECK(PRCRIMSG,"ICE4_TENDENCIES end:PRCRIMSG")
  CALL MPPDB_CHECK(PRSRIMCG,"ICE4_TENDENCIES end:PRSRIMCG")
  CALL MPPDB_CHECK(PRRACCSS,"ICE4_TENDENCIES end:PRRACCSS")
  CALL MPPDB_CHECK(PRRACCSG,"ICE4_TENDENCIES end:PRRACCSG")
  CALL MPPDB_CHECK(PRSACCRG,"ICE4_TENDENCIES end:PRSACCRG")
  CALL MPPDB_CHECK(PRVHENI_MR,"ICE4_TENDENCIES end:PRVHENI_MR")
  CALL MPPDB_CHECK(PRRHONG_MR,"ICE4_TENDENCIES end:PRRHONG_MR")
  CALL MPPDB_CHECK(PRIMLTC_MR,"ICE4_TENDENCIES end:PRIMLTC_MR")
  CALL MPPDB_CHECK(PRSRIMCG_MR,"ICE4_TENDENCIES end:PRSRIMCG_MR")
  CALL MPPDB_CHECK(PRCWETG,"ICE4_TENDENCIES end:PRCWETG")
  CALL MPPDB_CHECK(PRIWETG,"ICE4_TENDENCIES end:PRIWETG")
  CALL MPPDB_CHECK(PRRWETG,"ICE4_TENDENCIES end:PRRWETG")
  CALL MPPDB_CHECK(PRSWETG,"ICE4_TENDENCIES end:PRSWETG")
  CALL MPPDB_CHECK(PRCDRYG,"ICE4_TENDENCIES end:PRCDRYG")
  CALL MPPDB_CHECK(PRIDRYG,"ICE4_TENDENCIES end:PRIDRYG")
  CALL MPPDB_CHECK(PRRDRYG,"ICE4_TENDENCIES end:PRRDRYG")
  CALL MPPDB_CHECK(PRSDRYG,"ICE4_TENDENCIES end:PRSDRYG")
  CALL MPPDB_CHECK(PRWETGH,"ICE4_TENDENCIES end:PRWETGH")
  CALL MPPDB_CHECK(PRWETGH_MR,"ICE4_TENDENCIES end:PRWETGH_MR")
  CALL MPPDB_CHECK(PRCWETH,"ICE4_TENDENCIES end:PRCWETH")
  CALL MPPDB_CHECK(PRIWETH,"ICE4_TENDENCIES end:PRIWETH")
  CALL MPPDB_CHECK(PRSWETH,"ICE4_TENDENCIES end:PRSWETH")
  CALL MPPDB_CHECK(PRGWETH,"ICE4_TENDENCIES end:PRGWETH")
  CALL MPPDB_CHECK(PRRWETH,"ICE4_TENDENCIES end:PRRWETH")
  CALL MPPDB_CHECK(PRCDRYH,"ICE4_TENDENCIES end:PRCDRYH")
  CALL MPPDB_CHECK(PRIDRYH,"ICE4_TENDENCIES end:PRIDRYH")
  CALL MPPDB_CHECK(PRSDRYH,"ICE4_TENDENCIES end:PRSDRYH")
  CALL MPPDB_CHECK(PRRDRYH,"ICE4_TENDENCIES end:PRRDRYH")
  CALL MPPDB_CHECK(PRGDRYH,"ICE4_TENDENCIES end:PRGDRYH")
  CALL MPPDB_CHECK(PRDRYHG,"ICE4_TENDENCIES end:PRDRYHG")
  CALL MPPDB_CHECK(PA_TH,"ICE4_TENDENCIES end:PA_TH")
  CALL MPPDB_CHECK(PA_RV,"ICE4_TENDENCIES end:PA_RV")
  CALL MPPDB_CHECK(PA_RC,"ICE4_TENDENCIES end:PA_RC")
  CALL MPPDB_CHECK(PA_RR,"ICE4_TENDENCIES end:PA_RR")
  CALL MPPDB_CHECK(PA_RI,"ICE4_TENDENCIES end:PA_RI")
  CALL MPPDB_CHECK(PA_RS,"ICE4_TENDENCIES end:PA_RS")
  CALL MPPDB_CHECK(PA_RG,"ICE4_TENDENCIES end:PA_RG")
  CALL MPPDB_CHECK(PA_RH,"ICE4_TENDENCIES end:PA_RH")
  CALL MPPDB_CHECK(PB_TH,"ICE4_TENDENCIES end:PB_TH")
  CALL MPPDB_CHECK(PB_RV,"ICE4_TENDENCIES end:PB_RV")
  CALL MPPDB_CHECK(PB_RC,"ICE4_TENDENCIES end:PB_RC")
  CALL MPPDB_CHECK(PB_RR,"ICE4_TENDENCIES end:PB_RR")
  CALL MPPDB_CHECK(PB_RI,"ICE4_TENDENCIES end:PB_RI")
  CALL MPPDB_CHECK(PB_RS,"ICE4_TENDENCIES end:PB_RS")
  CALL MPPDB_CHECK(PB_RG,"ICE4_TENDENCIES end:PB_RG")
  CALL MPPDB_CHECK(PB_RH,"ICE4_TENDENCIES end:PB_RH")
  CALL MPPDB_CHECK(PHLC_HCF,"ICE4_TENDENCIES end:PHLC_HCF")
  CALL MPPDB_CHECK(PHLC_LCF,"ICE4_TENDENCIES end:PHLC_LCF")
  CALL MPPDB_CHECK(PHLC_HRC,"ICE4_TENDENCIES end:PHLC_HRC")
  CALL MPPDB_CHECK(PHLC_LRC,"ICE4_TENDENCIES end:PHLC_LRC")
  CALL MPPDB_CHECK(PRAINFR,"ICE4_TENDENCIES end:PRAINFR")
END IF
!
END SUBROUTINE ICE4_TENDENCIES
